VERSION 5.00
Begin VB.Form FrmDMusic 
   BorderStyle     =   0  'Kein
   Caption         =   "Dummy Form"
   ClientHeight    =   795
   ClientLeft      =   5835
   ClientTop       =   5130
   ClientWidth     =   2415
   LinkTopic       =   "Form2"
   ScaleHeight     =   795
   ScaleWidth      =   2415
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "FrmDMusic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Implements DirectXEvent8



'We need a loader object and a performance object
'We will play everything on our default audio path, so we do not need an audiopath object
Private dmp As DirectMusicPerformance8
Private dml As DirectMusicLoader8
Private dmSeg As DirectMusicSegment8
'Our event handle
Private dmEvent As Long

Public IsPlaying As Boolean


Public InGameMusic As Boolean

Public PlaylistLength As Long
Public PlaylistCurrent As Long






Public Sub PlayFile(ByVal nFileName As String, ByVal nLooped As Boolean)

    Set dmSeg = dml.LoadSegment(nFileName)
    'What type of music?
    If (Right$(nFileName, 4) = ".mid") Or (Right$(nFileName, 4) = ".rmi") Or (Right$(nFileName, 5) = ".midi") Then
        dmSeg.SetStandardMidiFile
        
    End If

    StopMusic

    If Not (dmSeg Is Nothing) Then
        If nLooped = True Then
            dmSeg.SetLoopPoints 0, 0
            dmSeg.SetRepeats -1 'Loop infinitely
        Else
            dmSeg.SetRepeats 0 'Don't loop
        End If
        
        dmp.PlaySegmentEx dmSeg, DMUS_SEGF_DEFAULT, 0
        Me.IsPlaying = True
    End If
End Sub

Public Sub StopMusic()

    If Not (dmSeg Is Nothing) Then
        dmp.StopEx dmSeg, 0, 0
       
        IsPlaying = False
    End If
    
End Sub

Private Sub DirectXEvent8_DXCallback(ByVal eventid As Long)
    Dim dmNotification As DMUS_NOTIFICATION_PMSG
    
    'We only have one event
    If Not dmp.GetNotificationPMSG(dmNotification) Then
      '  LOG.LOG "un-processed Notification recieved (dxcallback)"
       ' Exit Sub
    Else
        LOG.LOG "Got dmusic notification"
        If dmNotification.lNotificationOption = DMUS_NOTIFICATION_SEGEND Then 'The segment has ended
            Me.IsPlaying = False
 
            'Play new random file
            
        End If
    
    End If
End Sub


Public Sub InitAudio(dx As DirectX8, ByVal nhWnd As Long)
    On Error GoTo FailedInit
    'We need to create our objects now
    Set dmp = dx.DirectMusicPerformanceCreate
    Set dml = dx.DirectMusicLoaderCreate
    Dim dmusAudio As DMUS_AUDIOPARAMS
    
    'Now call init audio
    dmp.InitAudio nhWnd, DMUS_AUDIOF_ALL, dmusAudio, Nothing, DMUS_APATH_SHARED_STEREOPLUSREVERB, 128
    dmp.SetMasterAutoDownload True
    
    'Now add a notification for the segment
    dmp.AddNotificationType DMUS_NOTIFY_ON_SEGMENT
    'Create an event so we can receive these
    dmEvent = dx.CreateEvent(Me)
    dmp.SetNotificationHandle dmEvent

   'Me.LoadAndInitPlaylist App.Path & "\sfx\"

    Exit Sub
    
FailedInit:
    MsgBox "Could not initialize DirectMusic." & vbCrLf & "This sample will exit.", vbOKOnly Or vbInformation, "Exiting..."
    CleanupAudio modDXGFX8.DirectX
    Unload Me
    End
End Sub

Public Sub CleanupAudio(dx As DirectX8)
    'Cleanup everything
    On Error Resume Next
    dmp.RemoveNotificationType DMUS_NOTIFY_ON_SEGMENT
    
    dx.DestroyEvent dmEvent
    'If Not (dmSeg Is Nothing) Then dmp.StopEx dmSeg, 0, 0
    
    StopMusic
    
    Set dmSeg = Nothing
    Set dml = Nothing
    If Not (dmp Is Nothing) Then dmp.CloseDown
    Set dmp = Nothing
    
    Me.IsPlaying = False
    
    
    LOG.LOG "FrmDMusic.CleanupAudio successfully processed."
    

End Sub

'Private Sub Form_Unload(Cancel As Integer)
'    CleanupAudio
'End Sub



'Private Sub sldTempo_Click()
    'Update the tempo now
 '   dmp.SetMasterTempo (sldTempo.Value / 10)
'End Sub

'Private Sub sldTempo_Scroll()
 '   sldTempo_Click
'End Sub

'Private Sub sldVolume_Click()
 '   sldVolume_Scroll
'End Sub

'Private Sub sldVolume_Scroll()
    'Update the volume
 '   dmp.SetMasterVolume sldVolume.Value
'End Sub

'Private Sub EnableTempoControl(ByVal fEnable As Boolean)
    'If this is a wave file, turn off tempo control
    'fraTempo.Enabled = fEnable
    'sldTempo.Enabled = fEnable
    'lbl(4).Enabled = fEnable
    'lbl(5).Enabled = fEnable
    'lbl(6).Enabled = fEnable
    'If Not fEnable Then
    '    sldTempo.TickStyle = sldNoTicks
   'Else
  '      sldTempo.TickStyle = sldBottomRight
 '   End If
'End Sub




