Attribute VB_Name = "modDXGFX8"

Option Explicit
'This sample shows the easiest use of simple 2d sprites with DirectX 8.
'I think the code is quiet self-explanatory.
'
'A few lines are from:
'
'
'   By Matt Hafermann - matt@fusion-web.net
'   www.fusion-web.net/vb/
'
'and Lucky's Time-Modeling Tutorial (modTimer.bas)
'    rookscape.com/vbgaming/
'
'To contact me: goodguy@t-online.de
'
'I DO NOT CLAIM ANY RIGHTS ON THIS LINES. USE IT, STEEL IT, MODIFY IT, DO WHATEVER YOU WANT!
'
'But - please let me know if you use it in your game! :)
'
'Benedikt Engelhard
'
'
'Flexible vertex format the describes transformed and lit vertices.
Global Const FVF = D3DFVF_XYZRHW Or D3DFVF_TEX1 Or D3DFVF_DIFFUSE Or D3DFVF_SPECULAR

'This structure describes a transformed and lit vertex.
Type TLVERTEX
    X As Single
    Y As Single
    z As Single
    rhw As Single
    Color As Long
    specular As Long
    tu As Single
    tv As Single
End Type
    
    
    
    Global DirectX As DirectX8
    Public Direct3D As Direct3D8
    Public DisplayMode As D3DDISPLAYMODE
    Public Device As Direct3DDevice8
    Public d3dx As D3DX8
    
    
    Public surfBack    As Direct3DSurface8     'pointer to the backbuffer

    
    'Our Texture Pool
    Type TexturePool
        Texture As Direct3DTexture8
        Center As D3DVECTOR2
        Size As D3DVECTOR2
        Used As Boolean
    End Type
    Public Tex() As TexturePool
    'This Sprite will help us to draw all our Textures
    Dim Sprite As D3DXSprite
    
    'Our Font Pool
    Type FontPool
        dX8Font As D3DXFont
        Used As Boolean
    End Type
    Public D3DFont() As FontPool
    
    Public GlobalScaling As D3DVECTOR2
    Dim NoScaling As D3DVECTOR2
    
    Type MouseType
        Pos As D3DVECTOR2
        Clicked As Boolean
        LeftDown As Long
        RightDown As Long
        SlcTex As Long
        Visible As Boolean
    End Type
    
    Public Mouse As MouseType
    Public D3DPP As D3DPRESENT_PARAMETERS

Public Sub Initialize(ByVal nhWnd As Long, ByVal nWindowed As Boolean)
        On Error Resume Next

    
    'Set DX8 object!
    


    ' Initialize Direct3D
    Set Direct3D = DirectX.Direct3DCreate
    
    'Some more variables...
    Dim dmode As D3DDISPLAYMODE
    Dim D3DDM As D3DDISPLAYMODE
    
    Dim D3DCaps As D3DCAPS8

    

    Dim nAdapCount As Long

nAdapCount = Direct3D.GetAdapterCount

If nAdapCount > 1 Then
    nAdapCount = InputBox("more than one adapter detected. total count: " & nAdapCount & vbCrLf & "please enter device to use (0,1,2...):", "select adapter", 0)
    
Else
    nAdapCount = 0
End If


'Let's try it with hardware access
Dim DevType As CONST_D3DDEVTYPE
DevType = D3DDEVTYPE_HAL 'HAL->Hardware Access Layer
 
'Let's get the caps for the default device
Call Direct3D.GetDeviceCaps(nAdapCount, DevType, D3DCaps)
    
If Err.Number Then
    Err.Clear
'    Log.Log
    MsgBox "HAL not available, trying REF"
    DevType = D3DDEVTYPE_REF
    Call Direct3D.GetDeviceCaps(nAdapCount, DevType, D3DCaps)
    'Still error? Hell, what's wrong with this machine???
    
    If Err.Number Then
        MsgBox "Initialize->fatal error" 'hehe... nice microsoft-style error message *lol*
        End
    End If
End If


    
'Grab some information about the current display mode.
Call Direct3D.GetAdapterDisplayMode(nAdapCount, D3DDM)

'Now we'll go ahead and fill the D3DPRESENT_PARAMETERS type.
With D3DPP
    .Windowed = nWindowed

    .SwapEffect = D3DSWAPEFFECT_FLIP
    'Set the width and height to current resolution
    .BackBufferWidth = 800 ' D3DDM.Width
    .BackBufferHeight = 600 'D3DDM.Height
    
    
    'Set the backbuffer format
    '.BackBufferFormat = D3DDM.Format  'current format
    If nWindowed = False Then
        .BackBufferFormat = D3DFMT_R5G6B5   '16-bit
    Else
        .BackBufferFormat = D3DDM.Format  'current format
    End If
End With

'Try to create the device now that we have everything set.
Set Device = Direct3D.CreateDevice(nAdapCount, DevType, nhWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, D3DPP)

    ' make Load texture possible
    Set d3dx = New D3DX8

  'Some render states
  
'  d3dVP.Height = D3DDM.Height
 '
 'd3dVP.Width = D3DDM.Width
  'd3dVP.MaxZ = 1#
  'd3dVP.MinZ = 0#
  'd3dVP.X = 0
  'd3dVP.Y = 0
    
'  Device.SetVertexShader FVF
 'Device.SetViewport d3dVP
  
  'If Err.Number Then
   ' LOG.LOG "error setting viewport!"
  'End If
  
        
   ' Device.SetRenderState D3DRS_FILLMODE, D3DFILL_POINT
  '  Device.SetRenderState D3DRS_SHADEMODE, D3DSHADE_FLAT
 '   Device.SetRenderState D3DRS_LIGHTING, 0
'    Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
   
        'Set the vertex shader to an FVF that contains texture coords,
        'and transformed and lit vertex coords.
        

        
    'get our backbuffer handle!
    Set surfBack = Device.GetRenderTarget

   
  'If Err.Number Then
    'LOG.LOG "error creating vertex buffer!"
    'End
   ' End If
    
    ' Create our essential sprite
    Set Sprite = d3dx.CreateSprite(Device) 'cool, eh? no messing around with vertices ;-)
    
    Device.ShowCursor 1
    
Static initTex As Boolean
If initTex = False Then
    initTexturesAndFontPool
    initTex = True
End If
     
'    Log.Log "DXGFX8 successfully initialized"
End Sub

Public Function LoadTextureIntoPool(ByVal nFileName As String, nColorKey As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long 'Returns handle of texture in texturepool
Dim nRetryCount As Long
On Error GoTo Err_Loading_Texture

    Dim nTex As Long, n As Long
For n = 0 To UBound(Tex)
        If Tex(n).Used = False Then
            nTex = n
            GoTo AddTex
        End If
Next n
'No free texture, redim tex!

ReDim Preserve Tex(0 To UBound(Tex) + 1)

nTex = UBound(Tex)

AddTex:
    
    
    If DedicatedServer = True Then
    
        Static DDSTextInit As Boolean, DDSTex As Long
        
        If DDSTextInit = False Then
            Set Tex(nTex).Texture = d3dx.CreateTextureFromFileEx(Device, App.Path & "\art\stars\star1.bmp", -1, -1, D3DX_DEFAULT, 0, D3DFMT_UNKNOWN, D3DPOOL_MANAGED, D3DX_FILTER_POINT, D3DX_FILTER_POINT, nColorKey, ByVal 0, ByVal 0)
            DDSTex = nTex
        Else
            Set Tex(nTex).Texture = Nothing
        End If
        
        Tex(nTex).Size.X = nWidth
        Tex(nTex).Size.Y = nHeight
        
        Tex(nTex).Center.X = nWidth / 2
        Tex(nTex).Center.Y = nHeight / 2
        
        nTex = DDSTex
    Else
        Set Tex(nTex).Texture = d3dx.CreateTextureFromFileEx(Device, nFileName, -1, -1, D3DX_DEFAULT, 0, D3DFMT_UNKNOWN, D3DPOOL_MANAGED, D3DX_FILTER_POINT, D3DX_FILTER_POINT, nColorKey, ByVal 0, ByVal 0)
    
        'Let's find the center of our texture (for rotating)
        'We calculate it, so we may use ANY size of texture
        Dim texnfo As D3DSURFACE_DESC
        Tex(nTex).Texture.GetLevelDesc 0, texnfo
    
        Tex(nTex).Size.X = texnfo.Width
        Tex(nTex).Size.Y = texnfo.Height
        
        Tex(nTex).Center.X = texnfo.Width / 2
        Tex(nTex).Center.Y = texnfo.Height / 2
    End If


    LoadTextureIntoPool = nTex
    
    Tex(nTex).Used = True
    
'    Log.Log "Loaded texture " & nFileName & " size:(" & Tex(nTex).Size.X & "/" & Tex(nTex).Size.Y & ")"

  Exit Function

Err_Loading_Texture:
    LoadTextureIntoPool = -1
    nRetryCount = nRetryCount + 1
    LOG.LOG "Error " & Err.Number & " in LoadTextureIntoPool, file: " & nFileName & "...Retry: " & nRetryCount
    If nRetryCount > 10 Then
        MsgBox "Error loading texture " & nFileName & vbCrLf & "game will exit..."
        End
    End If
    GoTo AddTex
End Function

Public Sub ClearPrepareFrame()
        ' Clear screen
        'D3DColorRGBA(0, 0, 0, 255)
        
        
        
        Device.Clear 0, ByVal 0, D3DCLEAR_TARGET, D3DColorRGBA(0, 0, 0, 255), 1, &HFF
        ' 400: deep dark blue - use any other color u wish here!
        
        ' make draw sprite possible
        Device.BeginScene
        Sprite.Begin
        
        On Error Resume Next
        'open all fonts to be presented
        Dim i As Long
        For i = 0 To UBound(D3DFont)
            If D3DFont(i).Used = True Then
                D3DFont(i).dX8Font.Begin
            End If
        Next i

End Sub

Public Sub DisplaySprite(TexNr As Long, Pos As D3DVECTOR2, ByVal Rotation As Single, ByVal naffectedbyScaling As Boolean, Optional nColorCode)
    Static TempScaling As D3DVECTOR2
    Static TempCenter As D3DVECTOR2
    
    If TexNr < 0 Then Exit Sub
    
    If naffectedbyScaling = True Then
        TempScaling = GlobalScaling
        TempCenter.X = Tex(TexNr).Center.X * GlobalScaling.X
        TempCenter.Y = Tex(TexNr).Center.Y * GlobalScaling.Y
    Else
        TempScaling = NoScaling
        TempCenter = Tex(TexNr).Center
    End If
    
    
    If IsMissing(nColorCode) Then
        Sprite.Draw Tex(TexNr).Texture, ByVal 0, TempScaling, TempCenter, Rotation, Pos, -1
    Else
        Sprite.Draw Tex(TexNr).Texture, ByVal 0, TempScaling, TempCenter, Rotation, Pos, nColorCode 'D3DColorRGBA(255, 100, 100, 255) '&HFFFFFFFF
    End If
    
End Sub

Public Sub EndSceneDisplayFrame()
        ''close' all fonts to be presented
        On Error Resume Next
        Dim i As Long
        For i = 0 To UBound(D3DFont)
            If D3DFont(i).Used Then
                D3DFont(i).dX8Font.End
            End If
        Next i
        
        Sprite.End
        
        
        Device.EndScene
        
        Device.Present ByVal 0, ByVal 0, 0, ByVal 0

End Sub
Public Sub Destroy()
    'Into the garbage can:
     
    'Public DirectX As DirectX8
    'Public Direct3D As Direct3D8
    'Public DisplayMode As D3DDISPLAYMODE
    'Public Device As Direct3DDevice8
    'Public d3dx As D3DX8

    
    Set Sprite = Nothing
    Set Device = Nothing
    Set d3dx = Nothing
    Set Direct3D = Nothing


    
LOG.LOG "DXGFX8 objects successfully destroyed"
End Sub

Public Function CreateFont(nFontName As String, nSize As Long, nBold As Boolean, nItalic As Boolean, nUnderlined As Boolean) As Long   'Returns handle of font in fontpool

On Error GoTo Err_InCreateFont

Dim nFont As Long, n As Long

For n = 0 To UBound(D3DFont)
    If D3DFont(n).Used = False Then
        nFont = n: GoTo AddFont
    End If
Next n
'We need a new font place
ReDim Preserve D3DFont(0 To UBound(D3DFont) + 1)

nFont = UBound(D3DFont)

AddFont:

    'Dim A Font Object
    Dim m_vbFont As IFont
    Dim X As New StdFont
    
    X.Name = nFontName
    X.Bold = nBold
    X.Italic = nItalic
    X.Underline = nUnderlined
    X.Size = nSize
    
    Set m_vbFont = X
    
    Set D3DFont(nFont).dX8Font = d3dx.CreateFont(Device, m_vbFont.hFont)
    
    D3DFont(nFont).Used = True
    
    CreateFont = nFont 'Return font handle
    
    LOG.LOG "Font " & nFontName & " created (handle " & nFont & ")"  ' & Form1.Font.Name
Exit Function
Err_InCreateFont:
    LOG.LOG "Error " & Err.Number & " in CreateFont: " & nFontName
    
    CreateFont = -1
    
End Function

Sub D3DDrawText(ByVal strText As String, ByVal FontNr As Long, ByVal nColor As Long, fRect As RECT, Optional nFormat As Variant)


    '    D3DFont(FontNr).dX8Font.Begin
        If IsMissing(nFormat) Then
            d3dx.DrawText D3DFont(FontNr).dX8Font, nColor, strText, fRect, 0
        Else
            d3dx.DrawText D3DFont(FontNr).dX8Font, nColor, strText, fRect, nFormat
        End If
        
        'D3DFont(FontNr).dX8Font.DrawTextW strText, -1, fRect, 0, nColor
        'd3dx.DrawText dX8Font, &HFF000000, "Hallo Welt!", fRect, 0
        'dX8Font.DrawTextW "Hello World!", -1, fRect, DT_LEFT, RGB(255, 0, 0)
     '   D3DFont(FontNr).dX8Font.End
End Sub

Public Sub DrawLine(ByVal sngX1 As Single, ByVal sngY1 As Single, ByVal sngX2 As Single, ByVal sngY2 As Single, ByVal lngColor1 As Long)
On Error GoTo ErrorHandler

Dim V(0 To 1) As D3DTLVERTEX

V(0) = CreateTLVertex(sngX1, sngY1, 0, 1, lngColor1, 1, 0, 0)
V(1) = CreateTLVertex(sngX2, sngY2, 0, 1, lngColor1, 1, 0, 0)
'V(2) = CreateTLVertex(sngX2, sngY2, 0, 1, lngColor1, 1, 0, 0)
'log.log  "drawing line: " & V(0).x & "/" & V(0).y & " to " & V(1).x & "/" & V(1).y
'Device.SetTexture 0, Texture

'Now to remove a texture use:

Device.SetTexture 0, Nothing
'Device.SetVertexShader D3DFVF_VERTEX
Device.DrawPrimitiveUP D3DPT_LINELIST, 1, V(0), Len(V(0))

Exit Sub
ErrorHandler:
LOG.LOG "Error #" & Err.Number & ": " & Err.Description & " - DrawLine"
End
End Sub

Public Function CreateTLVertex(ByVal sngX As Single, ByVal sngY As Single, ByVal sngZ As Single, ByVal sngRhw As Single, ByVal lngColor As Long, ByVal lngSpecular As Long, ByVal sngTu As Single, ByVal sngTv As Single) As D3DTLVERTEX
Dim vVertex As D3DTLVERTEX
On Error GoTo ErrorHandler
With vVertex
.sx = sngX
.sy = sngY
.sz = sngZ
.rhw = sngRhw
.Color = lngColor
.specular = lngSpecular
.tu = sngTu
.tv = sngTv
End With
CreateTLVertex = vVertex
Exit Function

ErrorHandler:
LOG.LOG "Error #" & Err.Number & ": " & Err.Description & "CreateTLVertex"
End
End Function
Function GetNewSize(ByVal oSize As Long)
    Select Case oSize
        Case Is <= 8
            GetNewSize = 8
        Case Is <= 16
            GetNewSize = 16
        Case Is <= 32
            GetNewSize = 32
        Case Is <= 64
            GetNewSize = 64
        Case Is <= 128
            GetNewSize = 128
        Case Is <= 256
            GetNewSize = 256
        Case Is <= 512
            GetNewSize = 512
        Case Else
            GetNewSize = 0
    End Select
End Function


Public Sub InitGlobalDX8Object()
    Static DX8INITED As Boolean
    
    If DX8INITED = False Then
        Set DirectX = New DirectX8
        If DirectX Is Nothing Then
            MsgBox "DirectX 8 needed, sorry.", vbExclamation
            End
        End If
        DX8INITED = True
    End If
    
End Sub
Public Sub DestroyGlobalDX8Object()
    Set DirectX = Nothing
End Sub

Sub initTexturesAndFontPool()
    'Clear texture pool & font pool
    ReDim Tex(0)
    ReDim D3DFont(0)
    'Set standard scalings
    GlobalScaling.X = 1: GlobalScaling.Y = 1
    NoScaling.X = 1: NoScaling.Y = 1

End Sub
Public Sub deinitTexturesandFontPool()
On Error Resume Next
    Dim i As Long
    For i = 0 To UBound(Tex)
        'If Not Tex(i).Texture = Nothing Then
            Set Tex(i).Texture = Nothing
        'End If
    Next i
    ReDim Tex(0)
    
    For i = 0 To UBound(D3DFont)
        'If Not D3DFont(i).dX8Font = Nothing Then
            Set D3DFont(i).dX8Font = Nothing
        'End If
    Next i
    ReDim D3DFont(0)
End Sub

Public Sub PaintMouse()
    If Mouse.Visible = True Then
        modDXGFX8.DisplaySprite Mouse.SlcTex, Mouse.Pos, 0, False
    End If
End Sub

Public Sub UnloadSingleTexture(ByVal i As Long)
If Tex(i).Used = True Then
    'If Not Tex(i).Texture = Nothing Then
        Set Tex(i).Texture = Nothing
    'End If
    Tex(i).Used = False
End If
End Sub
